/* Process Copyright (C) 2004 Akbar <tuxer@myrealbox.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "Process.h"
#include <sstream>
#include <cstring>
#include <wait.h>
#include <vector>
using std::vector;

Process::Process() 
: temp(""),
  chars_read(0)
{
    memset(buffer,'\0',sizeof(buffer));
}

char Process::x_Prop() {
    read = popen("xprop -root _NET_NUMBER_OF_DESKTOPS","r");
    if(read!=NULL) {
        chars_read = fread(buffer, sizeof(char), 38, read);
        if(chars_read>0) {
            temp = buffer;
            pclose(read);
            return temp[36];
        }
    }
    return '\0';
}

string Process::child_Output( string input ) {
    string temp;
    read = popen(input.c_str(), "r");
    if(read!=NULL) {
        chars_read = fread(buffer, sizeof(char), OUTPUT, read);
        if(chars_read>0) {
            temp = buffer;
            temp[temp.length()-1] = '\0';
            pclose(read);
            return temp;
        }
    }
    return " ";
}

int Process::spawn( string input, bool waitChild ) {
    pid_t child;
    vector< string > list;
    string temp;

    std::stringstream os(input);
    int i = 0;
    while(os>>temp) {
        list.push_back(temp);
        i++;
    }

    char **arg;
    arg = new char* [i+1];

    for( int j = 0; j < i; j++ ) 
    {
        arg[j] = new char[list[j].length()];
        strcpy( arg[j], list[j].c_str() );
    }
    arg[i] = NULL;

    child = fork();

    if(child!=0) {
        if(waitChild) 
            wait(0);
        return child;
    }
    else 
        execvp(arg[0],arg);

    _exit(0);
}

int Process::spawn( char* program, char** arg_list, bool waitChild ) {
    pid_t child;

    child = fork();

    if(child!=0) {
        if(waitChild)
            wait(0);
        return child;
    }
    else 
        execvp(program, arg_list);

    _exit(0);
}


